<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Source of the Rust file `crates&#x2F;framework&#x2F;base&#x2F;icecap-fdt&#x2F;bindings&#x2F;src&#x2F;chosen.rs`."><meta name="keywords" content="rust, rustlang, rust-lang"><title>chosen.rs - source</title><link rel="stylesheet" type="text/css" href="../../normalize.css"><link rel="stylesheet" type="text/css" href="../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../light.css"  id="themeStyle"><link rel="stylesheet" type="text/css" href="../../dark.css" disabled ><link rel="stylesheet" type="text/css" href="../../ayu.css" disabled ><script id="default-settings" ></script><script src="../../storage.js"></script><script src="../../crates.js"></script><noscript><link rel="stylesheet" href="../../noscript.css"></noscript><link rel="alternate icon" type="image/png" href="../../favicon-16x16.png"><link rel="alternate icon" type="image/png" href="../../favicon-32x32.png"><link rel="icon" type="image/svg+xml" href="../../favicon.svg"><style type="text/css">#crate-search{background-image:url("../../down-arrow.svg");}</style></head><body class="rustdoc source"><!--[if lte IE 11]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="sidebar"><div class="sidebar-menu" role="button">&#9776;</div><a href='../../icecap_fdt_bindings/index.html'><div class='logo-container rust-logo'><img src='../../rust-logo.png' alt='logo'></div></a></nav><div class="theme-picker"><button id="theme-picker" aria-label="Pick another theme!" aria-haspopup="menu" title="themes"><img width="18" height="18" alt="Pick another theme!" src="../../brush.svg"></button><div id="theme-choices" role="menu"></div></div><nav class="sub"><form class="search-form"><div class="search-container"><div><select id="crate-search"><option value="All crates">All crates</option></select><input class="search-input" name="search" disabled autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"></div><button type="button" id="help-button" title="help">?</button><a id="settings-menu" href="../../settings.html" title="settings"><img width="18" height="18" alt="Change settings" src="../../wheel.svg"></a></div></form></nav><section id="main" class="content"><div class="example-wrap"><pre class="line-numbers"><span id="1"> 1</span>
<span id="2"> 2</span>
<span id="3"> 3</span>
<span id="4"> 4</span>
<span id="5"> 5</span>
<span id="6"> 6</span>
<span id="7"> 7</span>
<span id="8"> 8</span>
<span id="9"> 9</span>
<span id="10">10</span>
<span id="11">11</span>
<span id="12">12</span>
<span id="13">13</span>
<span id="14">14</span>
<span id="15">15</span>
<span id="16">16</span>
<span id="17">17</span>
<span id="18">18</span>
<span id="19">19</span>
<span id="20">20</span>
<span id="21">21</span>
<span id="22">22</span>
<span id="23">23</span>
<span id="24">24</span>
<span id="25">25</span>
<span id="26">26</span>
<span id="27">27</span>
<span id="28">28</span>
<span id="29">29</span>
<span id="30">30</span>
<span id="31">31</span>
<span id="32">32</span>
<span id="33">33</span>
<span id="34">34</span>
<span id="35">35</span>
<span id="36">36</span>
<span id="37">37</span>
<span id="38">38</span>
<span id="39">39</span>
<span id="40">40</span>
<span id="41">41</span>
<span id="42">42</span>
<span id="43">43</span>
<span id="44">44</span>
<span id="45">45</span>
<span id="46">46</span>
<span id="47">47</span>
<span id="48">48</span>
<span id="49">49</span>
<span id="50">50</span>
<span id="51">51</span>
<span id="52">52</span>
<span id="53">53</span>
<span id="54">54</span>
<span id="55">55</span>
</pre><pre class="rust"><code><span class="kw">use</span> <span class="ident">alloc::prelude::v1</span>::<span class="kw-2">*</span>;
<span class="kw">use</span> <span class="ident">core::ops::Range</span>;

<span class="kw">use</span> <span class="ident">serde</span>::{<span class="ident">Deserialize</span>, <span class="ident">Serialize</span>};

<span class="kw">use</span> <span class="ident">icecap_fdt</span>::{<span class="ident">DeviceTree</span>, <span class="ident">Node</span>};

<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Default</span>, <span class="ident">Debug</span>, <span class="ident">Clone</span>, <span class="ident">Serialize</span>, <span class="ident">Deserialize</span>)]</span>
<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">Chosen</span> {
    <span class="ident">bootargs</span>: <span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="ident">Vec</span><span class="op">&lt;</span><span class="ident">String</span><span class="op">&gt;</span><span class="op">&gt;</span>,
    <span class="ident">initrd</span>: <span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="ident">Range</span><span class="op">&lt;</span><span class="ident">usize</span><span class="op">&gt;</span><span class="op">&gt;</span>,
    <span class="ident">stdout_path</span>: <span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="ident">String</span><span class="op">&gt;</span>,
    <span class="ident">kaslr_seed</span>: <span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="ident">u64</span><span class="op">&gt;</span>,
}

<span class="kw">impl</span> <span class="ident">Chosen</span> {
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">set_bootargs</span>(<span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="self">self</span>, <span class="ident">bootargs</span>: <span class="ident">Vec</span><span class="op">&lt;</span><span class="ident">String</span><span class="op">&gt;</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="self">Self</span> {
        <span class="self">self</span>.<span class="ident">bootargs</span> <span class="op">=</span> <span class="prelude-val">Some</span>(<span class="ident">bootargs</span>);
        <span class="self">self</span>
    }

    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">set_initrd</span>(<span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="self">self</span>, <span class="ident">initrd</span>: <span class="ident">Range</span><span class="op">&lt;</span><span class="ident">usize</span><span class="op">&gt;</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="self">Self</span> {
        <span class="self">self</span>.<span class="ident">initrd</span> <span class="op">=</span> <span class="prelude-val">Some</span>(<span class="ident">initrd</span>);
        <span class="self">self</span>
    }

    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">set_stdout_path</span>(<span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="self">self</span>, <span class="ident">stdout_path</span>: <span class="ident">String</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="self">Self</span> {
        <span class="self">self</span>.<span class="ident">stdout_path</span> <span class="op">=</span> <span class="prelude-val">Some</span>(<span class="ident">stdout_path</span>);
        <span class="self">self</span>
    }

    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">set_kaslr_seed</span>(<span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="self">self</span>, <span class="ident">kaslr_seed</span>: <span class="ident">u64</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="self">Self</span> {
        <span class="self">self</span>.<span class="ident">kaslr_seed</span> <span class="op">=</span> <span class="prelude-val">Some</span>(<span class="ident">kaslr_seed</span>);
        <span class="self">self</span>
    }

    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">apply</span>(<span class="kw-2">&amp;</span><span class="self">self</span>, <span class="ident">dt</span>: <span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="ident">DeviceTree</span>) {
        <span class="kw">let</span> <span class="ident">spec</span> <span class="op">=</span> <span class="ident">dt</span>.<span class="ident">root</span>.<span class="ident">get_size_spec</span>();
        <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">node</span> <span class="op">=</span> <span class="ident">Node::new</span>();
        <span class="kw">if</span> <span class="kw">let</span> <span class="prelude-val">Some</span>(<span class="kw-2">ref</span> <span class="ident">bootargs</span>) <span class="op">=</span> <span class="self">self</span>.<span class="ident">bootargs</span> {
            <span class="ident">node</span>.<span class="ident">set_property</span>(<span class="string">&quot;bootargs&quot;</span>, <span class="ident">bootargs</span>.<span class="ident">join</span>(<span class="string">&quot; &quot;</span>).<span class="ident">as_str</span>());
        }
        <span class="kw">if</span> <span class="kw">let</span> <span class="prelude-val">Some</span>(<span class="kw-2">ref</span> <span class="ident">initrd</span>) <span class="op">=</span> <span class="self">self</span>.<span class="ident">initrd</span> {
            <span class="ident">node</span>.<span class="ident">set_property</span>(<span class="string">&quot;linux,initrd-start&quot;</span>, <span class="ident">spec</span>.<span class="ident">address</span>(<span class="ident">initrd</span>.<span class="ident">start</span>));
            <span class="ident">node</span>.<span class="ident">set_property</span>(<span class="string">&quot;linux,initrd-end&quot;</span>, <span class="ident">spec</span>.<span class="ident">address</span>(<span class="ident">initrd</span>.<span class="ident">end</span>));
        }
        <span class="kw">if</span> <span class="kw">let</span> <span class="prelude-val">Some</span>(<span class="kw-2">ref</span> <span class="ident">stdout_path</span>) <span class="op">=</span> <span class="self">self</span>.<span class="ident">stdout_path</span> {
            <span class="ident">node</span>.<span class="ident">set_property</span>(<span class="string">&quot;stdout-path&quot;</span>, <span class="ident">stdout_path</span>.<span class="ident">as_str</span>());
        }
        <span class="kw">if</span> <span class="kw">let</span> <span class="prelude-val">Some</span>(<span class="ident">kaslr_seed</span>) <span class="op">=</span> <span class="self">self</span>.<span class="ident">kaslr_seed</span> {
            <span class="ident">node</span>.<span class="ident">set_property</span>(<span class="string">&quot;kaslr-seed&quot;</span>, <span class="ident">kaslr_seed</span>);
        }
        <span class="ident">dt</span>.<span class="ident">root</span>.<span class="ident">set_child</span>(<span class="string">&quot;chosen&quot;</span>, <span class="ident">node</span>);
    }
}
</code></pre></div>
</section><section id="search" class="content hidden"></section><div id="rustdoc-vars" data-root-path="../../" data-current-crate="icecap_fdt_bindings" data-search-index-js="../../search-index.js" data-search-js="../../search.js"></div>
    <script src="../../main.js"></script><script src="../../source-script.js"></script><script src="../../source-files.js"></script>
</body></html>